import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.Assertions;


import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.util.ArrayList;

public class TestFunction {
    private ArrayList<Pilot> allPilots;

    public TestFunction() {
        this.allPilots = new ArrayList<>();
    }
    @Test
    public void TestIfBothFlightAreCorrect()
    {
        // Založte první Letiště (Airport)
        Airport airport1 = new Airport(1, "Prague");
        // Založte druhé letiště (Airport)
        Airport airport2 = new Airport(2, "Brno");
        // Založte první letadlo (Airplane)
        Airplane airplane = new Airplane(1000,AirplaneType.BOEING_737_MAX, 2015);
        // Založte druhé letadlo (Airplane)
        Airplane airplane2 = new Airplane(1001,AirplaneType.BOEING_737, 2009);
        // Založte prvního pilota (Pilot) a přidejte ho do systému
        Pilot pilot1 = new Pilot(10000,"Pavel",1990,2016);
        this.allPilots.add(pilot1);
        // Založte druhého pilota (Pilot) a přidejte ho do systému
        Pilot pilot2 = new Pilot(10001,"Petr",1982,2008);
        this.allPilots.add(pilot2);
        // Založte třetího pilota (Pilot) a přidejte ho do systému
        Pilot pilot3 = new Pilot(10002,"Adéla",1986,2018);
        this.allPilots.add(pilot3);
        // Založte třetího pilota (Pilot) a přidejte ho do systému
        Pilot pilot4 = new Pilot(10003,"Marek",1988,2019);
        this.allPilots.add(pilot4);
        //Přiřaď prvním dvěma pilotům certifikaci na letadlo "BOEING_737"
        pilot1.setCertification(AirplaneType.BOEING_737);
        pilot2.setCertification(AirplaneType.BOEING_737);
        //Přiřaď druhým dvěma pilotům certifikaci na letadlo "BOEING_737_MAX"
        pilot3.setCertification(AirplaneType.BOEING_737_MAX);
        pilot4.setCertification(AirplaneType.BOEING_737_MAX);
        // Založte let (Flight)
        LocalDate date = LocalDate.of(2020,8,9);
        LocalTime time = LocalTime.of(20,50);
        Flight flight = new Flight(700, "AB700", LocalDateTime.of(date, time),  airplane, airport1, airport2, 0,35);
        Flight flight2 = new Flight(701, "AB701", LocalDateTime.of(date, time),  airplane2, airport1, airport2, 0,35);


        // Pro všechny piloty v systému zkontrolujte jejich certifikaci
        // a pokud mají certifikaci na letadlo, které letí na letu s instancí "flight",
        // vyberte počet pilotů na letu ("numberOfPilotsAtFlight"), kteří budou pilotovat let
        choosePilotWithLicenceToFlight(flight, 2);
        choosePilotWithLicenceToFlight(flight2, 2);


        String result = "";
        /* Let 1 */
        result += ("Na letu 1 letí piloti: ");

        // Vypiš piloty na letu 1
        result += (flight.getPilotsNameOnFlight());

        // Vypiš rok narození každého z pilotů na letu 1 (příklad uvnitř metody getPilotsYearOfBirth() ve třídě Flight)
        result += (flight.getPilotsYearOfBirth());

        /* Konec letu 1 */



        /* Let 2 */
        result += ("Na letu 2 letí piloti: ");

        // Vypiš piloty na letu 2
        result+=(flight2.getPilotsNameOnFlight());

        // Vypiš rok narození každého z pilotů na letu 2 (příklad uvnitř metody getPilotsYearOfBirth() ve třídě Flight)
        result+= (flight2.getPilotsYearOfBirth());

        /* Konec letu 2 */

        Assertions.assertEquals(result, "Na letu 1 letí piloti: Adéla Marek " +
                "1. pilot je narozen v roce 1986\n" +
                "2. pilot je narozen v roce 1988\n" +
                "Na letu 2 letí piloti: Pavel Petr " +
                "1. pilot je narozen v roce 1990\n" +
                "2. pilot je narozen v roce 1982\n");
    }

    public void choosePilotWithLicenceToFlight(Flight flight, int numberOfPilotsAtFlight)
    {
        // Projdi všechny existující piloty
        for (Pilot onePilot: allPilots)
        {
            // Pokud má pilot certifikaci k letadlu na letu
            // MÁTE NAIMPLEMENTOVAT FUNKCI isPilotCertificatedOn, která vrací buď True nebo False
            if (onePilot.isPilotCertificatedOn(flight.getAirplane().getAirplaneType()))
            {
                // K letu pak přiřazuji pilota
                flight.addPilotToFlight(onePilot);

                // Počet pilotů, které hledám, zmenším o 1
                numberOfPilotsAtFlight--;

                // Když už jsme našli dva piloty, tak ukončíme hledání
                if (numberOfPilotsAtFlight < 1)
                    break;
            }
        }
    }
}
